/***************************************************************************
                          pairfold.h  -  description
                             -------------------
    begin                : Thu Apr 11 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef SIMFOLD_H
#define SIMFOLD_H

#define RNA   0
#define DNA   1

extern int noGU;


void init_data (char *config_file, int what, double temperature);
// the function that must be called by the main program to read data files
// PRE:  None
// POST: Read all data and configuration files


double simfold (char *sequence, char *structure);



double free_energy_simfold (char *sequence, char *structure);



double calc_Tm (double enthalpy, double entropy, double target_conc1, double target_conc2,
    int self_comp, double salt_conc);


#endif
